//#pragma comment(linker, "/SUBSYSTEM:WINDOWS") 
//#pragma comment(linker,"/ENTRY:WinMain")
//#include <windows.h> 
//#include <Wtsapi32.h>
#include "Userenv.h"
#include <conio.h>
#include <Tlhelp32.h>
#include <iosfwd>


#define WINSTA_ALL (WINSTA_ENUMDESKTOPS | WINSTA_READATTRIBUTES | \
	WINSTA_ACCESSCLIPBOARD | WINSTA_CREATEDESKTOP | \
	WINSTA_WRITEATTRIBUTES | WINSTA_ACCESSGLOBALATOMS | \
	WINSTA_EXITWINDOWS | WINSTA_ENUMERATE | WINSTA_READSCREEN | \
	STANDARD_RIGHTS_REQUIRED)


#define GENERIC_ACCESS (GENERIC_READ | GENERIC_WRITE | \
	GENERIC_EXECUTE | GENERIC_ALL)


#define DESKTOP_ALL (DESKTOP_READOBJECTS | DESKTOP_CREATEWINDOW | \
	DESKTOP_CREATEMENU | DESKTOP_HOOKCONTROL | DESKTOP_JOURNALRECORD | \
	DESKTOP_JOURNALPLAYBACK | DESKTOP_ENUMERATE | DESKTOP_WRITEOBJECTS | \
	DESKTOP_SWITCHDESKTOP | STANDARD_RIGHTS_REQUIRED)


HANDLE hpToken, hcopyToken,hProcess;
TOKEN_PRIVILEGES newToken;
LPVOID  pEnv = NULL;
STARTUPINFO sinfo;
PROCESS_INFORMATION  pinfo;

PROCESSENTRY32 procEntry;
DWORD GetProcessPid=0;

PSID pSid = NULL;

TOKEN_USER *ptu;
DWORD needed=0;
char aa[16384];

TCHAR DomainName[255];	
TCHAR buffer[255];
DWORD size=0;
DWORD DomainSize;

TCHAR WinDir[MAX_PATH] ;
DWORD dwBytesWritten = 0;
HANDLE hFile;

OVERLAPPED o; 


#pragma comment(lib, "Userenv.lib")

typedef DWORD (WINAPI* WTSGetActiveConsoleSessionId_)(VOID);
WTSGetActiveConsoleSessionId_ WTSGetActiveConsoleSessionIdMy=NULL;

typedef BOOL (WINAPI * ProcessIdToSessionId_)(DWORD,DWORD*);
ProcessIdToSessionId_ ProcessIdToSessionIdMy=NULL;


typedef BOOL (WINAPI* CreateEnvironmentBlock_)(LPVOID,HANDLE,BOOL);
CreateEnvironmentBlock_ CreateEnvironmentBlockMy=NULL;


BOOL RemoveAceFromWindowStation(HWINSTA hwinsta, PSID psid)
{
	ACL_SIZE_INFORMATION aclSizeInfo;
	BOOL                 bDaclExist;
	BOOL                 bDaclPresent;
	BOOL                 bSuccess = FALSE;
	DWORD                dwNewAclSize;
	DWORD                dwSidSize = 0;
	DWORD                dwSdSizeNeeded;
	PACL                 pacl;
	PACL                 pNewAcl;
	PSECURITY_DESCRIPTOR psd = NULL;
	PSECURITY_DESCRIPTOR psdNew = NULL;
	ACCESS_ALLOWED_ACE*  pTempAce;
	SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
	unsigned int         i;

	__try
	{
		// Obtain the DACL for the window station.

		if (!GetUserObjectSecurity(
			hwinsta,
			&si,
			psd,
			dwSidSize,
			&dwSdSizeNeeded)
			)
			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
			{
				psd = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded);

				if (psd == NULL)
					__leave;

				psdNew = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded);

				if (psdNew == NULL)
					__leave;

				dwSidSize = dwSdSizeNeeded;

				if (!GetUserObjectSecurity(
					hwinsta,
					&si,
					psd,
					dwSidSize,
					&dwSdSizeNeeded)
					)
					__leave;
			}
			else
				__leave;

		// Create a new DACL.

		if (!InitializeSecurityDescriptor(
			psdNew,
			SECURITY_DESCRIPTOR_REVISION)
			)
			__leave;

		// Get the DACL from the security descriptor.

		if (!GetSecurityDescriptorDacl(
			psd,
			&bDaclPresent,
			&pacl,
			&bDaclExist)
			)
			__leave;

		// Initialize the ACL.

		ZeroMemory(&aclSizeInfo, sizeof(ACL_SIZE_INFORMATION));
		aclSizeInfo.AclBytesInUse = sizeof(ACL);

		// Call only if the DACL is not NULL.

		if (pacl != NULL)
		{
			// get the file ACL size info
			if (!GetAclInformation(
				pacl,
				(LPVOID)&aclSizeInfo,
				sizeof(ACL_SIZE_INFORMATION),
				AclSizeInformation)
				)
				__leave;
		}

		// Compute the size of the new ACL.

		dwNewAclSize = aclSizeInfo.AclBytesInUse +
			(2*sizeof(ACCESS_ALLOWED_ACE)) + (2*GetLengthSid(psid)) -
			(2*sizeof(DWORD));

		// Allocate memory for the new ACL.

		pNewAcl = (PACL)HeapAlloc(
			GetProcessHeap(),
			HEAP_ZERO_MEMORY,
			dwNewAclSize);

		if (pNewAcl == NULL)
			__leave;

		// Initialize the new DACL.

		if (!InitializeAcl(pNewAcl, dwNewAclSize, ACL_REVISION))
			__leave;

		// If DACL is present, copy it to a new DACL.

		if (bDaclPresent)
		{
			// Copy the ACEs to the new ACL.
			if (aclSizeInfo.AceCount)
			{
				for (i=0; i < aclSizeInfo.AceCount; i++)
				{
					// Get an ACE.
					if (!GetAce(pacl, i, reinterpret_cast<void**>(&pTempAce)))
						__leave;

					if ( !EqualSid( psid, &pTempAce->SidStart ) )
					{

						// Add the ACE to the new ACL.
						if (!AddAce(
							pNewAcl,
							ACL_REVISION,
							MAXDWORD,
							pTempAce,
							((PACE_HEADER)pTempAce)->AceSize)
							)
							__leave;
					}
				}
			}
		}

		if( pacl != NULL )
			HeapFree(GetProcessHeap(), 0, (LPVOID)pacl);

		// Set a new DACL for the security descriptor.

		if (!SetSecurityDescriptorDacl(
			psdNew,
			TRUE,
			pNewAcl,
			FALSE)
			)
			__leave;

		// Set the new security descriptor for the window station.

		if (!SetUserObjectSecurity(hwinsta, &si, psdNew))
			__leave;

		// Indicate success.

		bSuccess = TRUE;
	}
	__finally
	{
		// Free the allocated buffers.

		if( pacl != NULL )
			HeapFree(GetProcessHeap(), 0, (LPVOID)pacl);

		if (pNewAcl != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)pNewAcl);

		if (psd != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

		if (psdNew != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psdNew);
	}

	return bSuccess;

}

BOOL RemoveAceFromDesktop(HDESK hdesk, PSID psid)
{
	ACL_SIZE_INFORMATION aclSizeInfo;
	BOOL                 bDaclExist;
	BOOL                 bDaclPresent;
	BOOL                 bSuccess = FALSE;
	DWORD                dwNewAclSize;
	DWORD                dwSidSize = 0;
	DWORD                dwSdSizeNeeded;
	PACL                 pacl;
	PACL                 pNewAcl;
	PSECURITY_DESCRIPTOR psd = NULL;
	PSECURITY_DESCRIPTOR psdNew = NULL;
	ACCESS_ALLOWED_ACE*  pTempAce;
	SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
	unsigned int         i;

	__try
	{
		// Obtain the security descriptor for the desktop object.

		if (!GetUserObjectSecurity(
			hdesk,
			&si,
			psd,
			dwSidSize,
			&dwSdSizeNeeded))
		{
			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
			{
				psd = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded );

				if (psd == NULL)
					__leave;

				psdNew = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded);

				if (psdNew == NULL)
					__leave;

				dwSidSize = dwSdSizeNeeded;

				if (!GetUserObjectSecurity(
					hdesk,
					&si,
					psd,
					dwSidSize,
					&dwSdSizeNeeded)
					)
					__leave;
			}
			else
				__leave;
		}

		// Create a new security descriptor.

		if (!InitializeSecurityDescriptor(
			psdNew,
			SECURITY_DESCRIPTOR_REVISION)
			)
			__leave;

		// Obtain the DACL from the security descriptor.

		if (!GetSecurityDescriptorDacl(
			psd,
			&bDaclPresent,
			&pacl,
			&bDaclExist)
			)
			__leave;

		// Initialize.

		ZeroMemory(&aclSizeInfo, sizeof(ACL_SIZE_INFORMATION));
		aclSizeInfo.AclBytesInUse = sizeof(ACL);

		// Call only if NULL DACL.

		if (pacl != NULL)
		{
			// Determine the size of the ACL information.

			if (!GetAclInformation(
				pacl,
				(LPVOID)&aclSizeInfo,
				sizeof(ACL_SIZE_INFORMATION),
				AclSizeInformation)
				)
				__leave;
		}

		// Compute the size of the new ACL.

		dwNewAclSize = aclSizeInfo.AclBytesInUse +
			sizeof(ACCESS_ALLOWED_ACE) +
			GetLengthSid(psid) - sizeof(DWORD);

		// Allocate buffer for the new ACL.

		pNewAcl = (PACL)HeapAlloc(
			GetProcessHeap(),
			HEAP_ZERO_MEMORY,
			dwNewAclSize);

		if (pNewAcl == NULL)
			__leave;

		// Initialize the new ACL.

		if (!InitializeAcl(pNewAcl, dwNewAclSize, ACL_REVISION))
			__leave;

		// If DACL is present, copy it to a new DACL.

		if (bDaclPresent)
		{
			// Copy the ACEs to the new ACL.
			if (aclSizeInfo.AceCount)
			{
				for (i=0; i < aclSizeInfo.AceCount; i++)
				{
					// Get an ACE.
					if (!GetAce(pacl, i, reinterpret_cast<void**>(&pTempAce)))
						__leave;

					if ( !EqualSid( psid, &pTempAce->SidStart ) )
					{

						// Add the ACE to the new ACL.
						if (!AddAce(
							pNewAcl,
							ACL_REVISION,
							MAXDWORD,
							pTempAce,
							((PACE_HEADER)pTempAce)->AceSize)
							)
							__leave;
					}
				}
			}
		}

		// Set new DACL to the new security descriptor.

		if (!SetSecurityDescriptorDacl(
			psdNew,
			TRUE,
			pNewAcl,
			FALSE)
			)
			__leave;

		// Set the new security descriptor for the desktop object.

		if (!SetUserObjectSecurity(hdesk, &si, psdNew))
			__leave;

		// Indicate success.

		bSuccess = TRUE;
	}
	__finally
	{
		// Free buffers.

		if( pacl != NULL )
			HeapFree(GetProcessHeap(), 0, (LPVOID)pacl);

		if (pNewAcl != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)pNewAcl);

		if (psd != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

		if (psdNew != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psdNew);
	}

	return bSuccess;
}



BOOL AddAceToDesktop(HDESK hdesk, PSID psid)
{
	ACL_SIZE_INFORMATION aclSizeInfo;
	BOOL                 bDaclExist;
	BOOL                 bDaclPresent;
	BOOL                 bSuccess = FALSE;
	DWORD                dwNewAclSize;
	DWORD                dwSidSize = 0;
	DWORD                dwSdSizeNeeded;
	PACL                 pacl;
	PACL                 pNewAcl;
	PSECURITY_DESCRIPTOR psd = NULL;
	PSECURITY_DESCRIPTOR psdNew = NULL;
	PVOID                pTempAce;
	SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
	unsigned int         i;

	__try
	{
		// Obtain the security descriptor for the desktop object.

		if (!GetUserObjectSecurity(
			hdesk,
			&si,
			psd,
			dwSidSize,
			&dwSdSizeNeeded))
		{
			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
			{
				psd = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded );

				if (psd == NULL)
					__leave;

				psdNew = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded);

				if (psdNew == NULL)
					__leave;

				dwSidSize = dwSdSizeNeeded;

				if (!GetUserObjectSecurity(
					hdesk,
					&si,
					psd,
					dwSidSize,
					&dwSdSizeNeeded)
					)
					__leave;
			}
			else
				__leave;
		}

		// Create a new security descriptor.

		if (!InitializeSecurityDescriptor(
			psdNew,
			SECURITY_DESCRIPTOR_REVISION)
			)
			__leave;

		// Obtain the DACL from the security descriptor.

		if (!GetSecurityDescriptorDacl(
			psd,
			&bDaclPresent,
			&pacl,
			&bDaclExist)
			)
			__leave;

		// Initialize.

		ZeroMemory(&aclSizeInfo, sizeof(ACL_SIZE_INFORMATION));
		aclSizeInfo.AclBytesInUse = sizeof(ACL);

		// Call only if NULL DACL.

		if (pacl != NULL)
		{
			// Determine the size of the ACL information.

			if (!GetAclInformation(
				pacl,
				(LPVOID)&aclSizeInfo,
				sizeof(ACL_SIZE_INFORMATION),
				AclSizeInformation)
				)
				__leave;
		}

		// Compute the size of the new ACL.

		dwNewAclSize = aclSizeInfo.AclBytesInUse +
			sizeof(ACCESS_ALLOWED_ACE) +
			GetLengthSid(psid) - sizeof(DWORD);

		// Allocate buffer for the new ACL.

		pNewAcl = (PACL)HeapAlloc(
			GetProcessHeap(),
			HEAP_ZERO_MEMORY,
			dwNewAclSize);

		if (pNewAcl == NULL)
			__leave;

		// Initialize the new ACL.

		if (!InitializeAcl(pNewAcl, dwNewAclSize, ACL_REVISION))
			__leave;

		// If DACL is present, copy it to a new DACL.

		if (bDaclPresent)
		{
			// Copy the ACEs to the new ACL.
			if (aclSizeInfo.AceCount)
			{
				for (i=0; i < aclSizeInfo.AceCount; i++)
				{
					// Get an ACE.
					if (!GetAce(pacl, i, &pTempAce))
						__leave;

					// Add the ACE to the new ACL.
					if (!AddAce(
						pNewAcl,
						ACL_REVISION,
						MAXDWORD,
						pTempAce,
						((PACE_HEADER)pTempAce)->AceSize)
						)
						__leave;
				}
			}
		}

		// Add ACE to the DACL.

		if (!AddAccessAllowedAce(
			pNewAcl,
			ACL_REVISION,
			DESKTOP_ALL,
			psid)
			)
			__leave;

		// Set new DACL to the new security descriptor.

		if (!SetSecurityDescriptorDacl(
			psdNew,
			TRUE,
			pNewAcl,
			FALSE)
			)
			__leave;

		// Set the new security descriptor for the desktop object.

		if (!SetUserObjectSecurity(hdesk, &si, psdNew))
			__leave;

		// Indicate success.

		bSuccess = TRUE;
	}
	__finally
	{
		// Free buffers.

		if (pNewAcl != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)pNewAcl);

		if (psd != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

		if (psdNew != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psdNew);
	}

	return bSuccess;
}


BOOL GetLogonSID (HANDLE hToken, PSID *ppsid) 
{
	BOOL bSuccess = FALSE;
	DWORD dwIndex;
	DWORD dwLength = 0;
	PTOKEN_GROUPS ptg = NULL;

	// Verify the parameter passed in is not NULL.
	if (NULL == ppsid)
		goto Cleanup;

	// Get required buffer size and allocate the TOKEN_GROUPS buffer.

	if (!GetTokenInformation(
		hToken,         // handle to the access token
		TokenGroups,    // get information about the token's groups 
		(LPVOID) ptg,   // pointer to TOKEN_GROUPS buffer
		0,              // size of buffer
		&dwLength       // receives required buffer size
		)) 
	{
		if (GetLastError() != ERROR_INSUFFICIENT_BUFFER) 
			goto Cleanup;

		ptg = (PTOKEN_GROUPS)HeapAlloc(GetProcessHeap(),
			HEAP_ZERO_MEMORY, dwLength);

		if (ptg == NULL)
			goto Cleanup;
	}

	// Get the token group information from the access token.

	if (!GetTokenInformation(
		hToken,         // handle to the access token
		TokenGroups,    // get information about the token's groups 
		(LPVOID) ptg,   // pointer to TOKEN_GROUPS buffer
		dwLength,       // size of buffer
		&dwLength       // receives required buffer size
		)) 
	{
		goto Cleanup;
	}

	// Loop through the groups to find the logon SID.

	for (dwIndex = 0; dwIndex < ptg->GroupCount; dwIndex++) 
		if ((ptg->Groups[dwIndex].Attributes & SE_GROUP_LOGON_ID)
			==  SE_GROUP_LOGON_ID) 
		{
			// Found the logon SID; make a copy of it.

			dwLength = GetLengthSid(ptg->Groups[dwIndex].Sid);
			*ppsid = (PSID) HeapAlloc(GetProcessHeap(),
				HEAP_ZERO_MEMORY, dwLength);
			if (*ppsid == NULL)
				goto Cleanup;
			if (!CopySid(dwLength, *ppsid, ptg->Groups[dwIndex].Sid)) 
			{
				HeapFree(GetProcessHeap(), 0, (LPVOID)*ppsid);
				goto Cleanup;
			}
			break;
		}

		bSuccess = TRUE;

Cleanup: 

		// Free the buffer for the token groups.

		if (ptg != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)ptg);

		return bSuccess;
}

BOOL AddAceToWindowStation(HWINSTA hwinsta, PSID psid)
{
	ACCESS_ALLOWED_ACE   *pace;
	ACL_SIZE_INFORMATION aclSizeInfo;
	BOOL                 bDaclExist;
	BOOL                 bDaclPresent;
	BOOL                 bSuccess = FALSE;
	DWORD                dwNewAclSize;
	DWORD                dwSidSize = 0;
	DWORD                dwSdSizeNeeded;
	PACL                 pacl;
	PACL                 pNewAcl;
	PSECURITY_DESCRIPTOR psd = NULL;
	PSECURITY_DESCRIPTOR psdNew = NULL;
	PVOID                pTempAce;
	SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
	unsigned int         i;

	__try
	{
		// Obtain the DACL for the window station.

		if (!GetUserObjectSecurity(
			hwinsta,
			&si,
			psd,
			dwSidSize,
			&dwSdSizeNeeded)
			)
			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
			{
				psd = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded);

				if (psd == NULL)
					__leave;

				psdNew = (PSECURITY_DESCRIPTOR)HeapAlloc(
					GetProcessHeap(),
					HEAP_ZERO_MEMORY,
					dwSdSizeNeeded);

				if (psdNew == NULL)
					__leave;

				dwSidSize = dwSdSizeNeeded;

				if (!GetUserObjectSecurity(
					hwinsta,
					&si,
					psd,
					dwSidSize,
					&dwSdSizeNeeded)
					)
					__leave;
			}
			else
				__leave;

		// Create a new DACL.

		if (!InitializeSecurityDescriptor(
			psdNew,
			SECURITY_DESCRIPTOR_REVISION)
			)
			__leave;

		// Get the DACL from the security descriptor.

		if (!GetSecurityDescriptorDacl(
			psd,
			&bDaclPresent,
			&pacl,
			&bDaclExist)
			)
			__leave;

		// Initialize the ACL.

		ZeroMemory(&aclSizeInfo, sizeof(ACL_SIZE_INFORMATION));
		aclSizeInfo.AclBytesInUse = sizeof(ACL);

		// Call only if the DACL is not NULL.

		if (pacl != NULL)
		{
			// get the file ACL size info
			if (!GetAclInformation(
				pacl,
				(LPVOID)&aclSizeInfo,
				sizeof(ACL_SIZE_INFORMATION),
				AclSizeInformation)
				)
				__leave;
		}

		// Compute the size of the new ACL.

		dwNewAclSize = aclSizeInfo.AclBytesInUse +
			(2*sizeof(ACCESS_ALLOWED_ACE)) + (2*GetLengthSid(psid)) -
			(2*sizeof(DWORD));

		// Allocate memory for the new ACL.

		pNewAcl = (PACL)HeapAlloc(
			GetProcessHeap(),
			HEAP_ZERO_MEMORY,
			dwNewAclSize);

		if (pNewAcl == NULL)
			__leave;

		// Initialize the new DACL.

		if (!InitializeAcl(pNewAcl, dwNewAclSize, ACL_REVISION))
			__leave;

		// If DACL is present, copy it to a new DACL.

		if (bDaclPresent)
		{
			// Copy the ACEs to the new ACL.
			if (aclSizeInfo.AceCount)
			{
				for (i=0; i < aclSizeInfo.AceCount; i++)
				{
					// Get an ACE.
					if (!GetAce(pacl, i, &pTempAce))
						__leave;

					// Add the ACE to the new ACL.
					if (!AddAce(
						pNewAcl,
						ACL_REVISION,
						MAXDWORD,
						pTempAce,
						((PACE_HEADER)pTempAce)->AceSize)
						)
						__leave;
				}
			}
		}

		// Add the first ACE to the window station.

		pace = (ACCESS_ALLOWED_ACE *)HeapAlloc(
			GetProcessHeap(),
			HEAP_ZERO_MEMORY,
			sizeof(ACCESS_ALLOWED_ACE) + GetLengthSid(psid) -
			sizeof(DWORD));

		if (pace == NULL)
			__leave;

		pace->Header.AceType  = ACCESS_ALLOWED_ACE_TYPE;
		pace->Header.AceFlags = CONTAINER_INHERIT_ACE |
			INHERIT_ONLY_ACE | OBJECT_INHERIT_ACE;
		pace->Header.AceSize  = sizeof(ACCESS_ALLOWED_ACE) +
			GetLengthSid(psid) - sizeof(DWORD);
		pace->Mask            = GENERIC_ACCESS;

		if (!CopySid(GetLengthSid(psid), &pace->SidStart, psid))
			__leave;

		if (!AddAce(
			pNewAcl,
			ACL_REVISION,
			MAXDWORD,
			(LPVOID)pace,
			pace->Header.AceSize)
			)
			__leave;

		// Add the second ACE to the window station.

		pace->Header.AceFlags = NO_PROPAGATE_INHERIT_ACE;
		pace->Mask            = WINSTA_ALL;

		if (!AddAce(
			pNewAcl,
			ACL_REVISION,
			MAXDWORD,
			(LPVOID)pace,
			pace->Header.AceSize)
			)
			__leave;

		// Set a new DACL for the security descriptor.

		if (!SetSecurityDescriptorDacl(
			psdNew,
			TRUE,
			pNewAcl,
			FALSE)
			)
			__leave;

		// Set the new security descriptor for the window station.

		if (!SetUserObjectSecurity(hwinsta, &si, psdNew))
			__leave;

		// Indicate success.

		bSuccess = TRUE;
	}
	__finally
	{
		// Free the allocated buffers.

		if (pace != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)pace);

		if (pNewAcl != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)pNewAcl);

		if (psd != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

		if (psdNew != NULL)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psdNew);
	}

	return bSuccess;

}


int main(int argc, char *argv[])

{

	GetSystemWindowsDirectory(WinDir,MAX_PATH);

	//Sleep(10000);
	
	TCHAR strExe[255],procExe_pid[255];
	LPWSTR *szArglist;
    int nArgs;

    szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);
	if (nArgs>2)
	{
	wsprintf (strExe,L"%s",szArglist[1]);
	wsprintf (procExe_pid,L"%s",szArglist[2]);
	}
	else
	{
		LocalFree(szArglist);
		return 0;
	}

    LocalFree(szArglist);
	HWINSTA     hwinsta = NULL, hwinstaSave = NULL;
	HDESK       hdesk = NULL;
	ZeroMemory( &sinfo, sizeof(sinfo));
	sinfo.cb = sizeof(sinfo); 
	sinfo.lpDesktop= L"WinSta0\\Default";

	HMODULE krn32 = LoadLibrary(L"kernel32.dll");

	WTSGetActiveConsoleSessionIdMy =(WTSGetActiveConsoleSessionId_)GetProcAddress(krn32,"WTSGetActiveConsoleSessionId"); 
	ProcessIdToSessionIdMy=(ProcessIdToSessionId_)GetProcAddress(krn32, "ProcessIdToSessionId");

	if (WTSGetActiveConsoleSessionIdMy==NULL)
		return 0;

	if (ProcessIdToSessionIdMy==NULL)
		return 0;
	

DWORD  sessionID=WTSGetActiveConsoleSessionIdMy(); 
HANDLE hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

if (hSnap == INVALID_HANDLE_VALUE)
{
	
	return 0 ;
}

procEntry.dwSize = sizeof(PROCESSENTRY32);

if (!Process32First(hSnap, &procEntry))
{
	CloseHandle(hSnap);
	return 0 ;
}

int mypid=_wtoi(procExe_pid);

if (mypid>0)
{
	do
	{
		if (procEntry.th32ProcessID==mypid)
		{
          GetProcessPid = procEntry.th32ProcessID;	
		  break;
		}
		
	} 
	while (Process32Next(hSnap, &procEntry));

}

else
{
do
{
	if (_wcsicmp (procEntry.szExeFile, procExe_pid) == 0)
	{
		DWORD dwExplorerSessId = 0;

		if (ProcessIdToSessionIdMy!=NULL)
		{
			if (ProcessIdToSessionIdMy(procEntry.th32ProcessID, &dwExplorerSessId) && dwExplorerSessId == sessionID)
			{
				GetProcessPid = procEntry.th32ProcessID;
				break;
			}
		}
		else GetProcessPid = procEntry.th32ProcessID;
	}

} 
while (Process32Next(hSnap, &procEntry));
}


CloseHandle(hSnap);

if (GetProcessPid==0) 
return 0;

hProcess = OpenProcess(MAXIMUM_ALLOWED,FALSE,GetProcessPid);

if(!OpenProcessToken(hProcess,TOKEN_ALL_ACCESS,&hpToken))
{
	FreeLibrary(krn32);
	return 0;
}

if(!LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &newToken.Privileges[0].Luid)) 

{

	CloseHandle(hpToken); 
	CloseHandle(hProcess);
	FreeLibrary(krn32);
	return 0;
}

newToken.PrivilegeCount=1; 
newToken.Privileges[0].Attributes=SE_PRIVILEGE_ENABLED; 

//HANDLE hTokenthis = NULL;
//if (!WTSQueryUserToken(WTSGetActiveConsoleSessionId(), &hTokenthis))
//{
//	DWORD res=GetLastError(); 
//	LPTSTR s;

//	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
//		FORMAT_MESSAGE_FROM_SYSTEM,
//		NULL,
//		res,
//		0,
//		(LPTSTR)&s,
//		0,
//		NULL);
//	MessageBox(NULL,s,L"ERROR",MB_ICONSTOP);
//	CloseHandle(hpToken); 
//FreeLibrary(krn32);
//	return 0;
//}


if(!DuplicateTokenEx(hpToken, MAXIMUM_ALLOWED, NULL, SecurityImpersonation, TokenPrimary, &hcopyToken)) 
{
	CloseHandle(hpToken);  
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}

if(!SetTokenInformation(hcopyToken, TokenSessionId, &sessionID, sizeof(sessionID))) 
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}

if (! AdjustTokenPrivileges(hcopyToken, FALSE, &newToken, 0,(PTOKEN_PRIVILEGES)NULL,0))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}



if(!CreateEnvironmentBlock(&pEnv, hcopyToken, true))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess);
	FreeLibrary(krn32);
	return 0;

}

if ((hwinstaSave = GetProcessWindowStation())==NULL)

{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}


hwinsta = OpenWindowStation(L"winsta0", FALSE, READ_CONTROL | WRITE_DAC); 

if (hwinsta == NULL) 
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 	
	FreeLibrary(krn32);
	return 0;
}


if (!SetProcessWindowStation(hwinsta))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}

hdesk = OpenDesktop(L"default", 0, FALSE, READ_CONTROL | WRITE_DAC | DESKTOP_WRITEOBJECTS | DESKTOP_READOBJECTS);

if (hdesk == NULL) 
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}

if (!SetProcessWindowStation(hwinstaSave))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}


ptu = (TOKEN_USER *) aa;
if (GetTokenInformation( hcopyToken, TokenUser, ptu, 16384, &needed ) )
{
	DomainSize =sizeof(DomainName)-1;
	SID_NAME_USE SidType;
	DWORD dwsize=255;
	LookupAccountSid(NULL, ptu->User.Sid, buffer, &dwsize, DomainName, &DomainSize, &SidType);
    DomainName[0]='0';
    buffer[0]='0';
}


//if (!GetLogonSID(hcopyToken, &pSid))
//{
//	DWORD res=GetLastError(); 
//	LPTSTR s;

//	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
//		FORMAT_MESSAGE_FROM_SYSTEM,
//		NULL,
//		res,
//		0,
//		(LPTSTR)&s,
//		0,
//		NULL);
//	MessageBox(NULL,s,L"ERROR",MB_ICONSTOP);
//	CloseHandle(hpToken); 
//	CloseHandle(hcopyToken); 
//	CloseHandle(hProcess); 
//	return 0;
//}


if (!AddAceToWindowStation(hwinsta, ptu->User.Sid))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}


if (!AddAceToDesktop(hdesk, ptu->User.Sid))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}

if (!ImpersonateLoggedOnUser(hcopyToken))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
	return 0;
}


TCHAR FullPath[255];

wsprintf (FullPath,L"%s%s%s",WinDir,L"\\",strExe);

if (!CreateProcessAsUser(hcopyToken, FullPath, NULL, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE |CREATE_UNICODE_ENVIRONMENT, NULL, NULL,&sinfo, &pinfo))
{
	CloseHandle(hpToken); 
	CloseHandle(hcopyToken); 
	CloseHandle(hProcess); 
	FreeLibrary(krn32);
    return 0;
}

RevertToSelf();

if (pinfo.hProcess != INVALID_HANDLE_VALUE) 
{ 
	WaitForSingleObject(pinfo.hProcess, INFINITE); 
	CloseHandle(pinfo.hProcess); 
} 

if (pinfo.hThread != INVALID_HANDLE_VALUE)
CloseHandle(pinfo.hThread);  

RemoveAceFromWindowStation(hwinsta, ptu->User.Sid);
RemoveAceFromDesktop(hdesk, ptu->User.Sid);

if (hwinstaSave != NULL)
SetProcessWindowStation (hwinstaSave);

if (hwinsta)
CloseWindowStation(hwinsta);

if (hdesk)
CloseDesktop(hdesk);

CloseHandle(hpToken); 
CloseHandle(hcopyToken); 
CloseHandle(hProcess); 
FreeLibrary(krn32);
return 0;
}
