//#pragma comment(linker,"/ENTRY:main")

#define UNICODE
//#define BUFSIZE 32767
#define BUFSIZE 4096
#define INFO_BUFFER_SIZE 32767
#define MAX_KEY_LENGTH 255
#define MAX_VALUE_NAME 16383

#pragma comment(lib, "winmm.lib")

#include "pipe_server.h"
#include "resource.h"
#include <Tlhelp32.h>
#include <tchar.h>

LPTSTR lpszPipename = L"\\\\.\\pipe\\my_pipe_server_";
TCHAR msg[BUFSIZE],cmd[BUFSIZE],param[BUFSIZE];
HINSTANCE nResult;
TCHAR imgbuf[INFO_BUFFER_SIZE];
TCHAR Replay[BUFSIZE];
TCHAR  compname[MAX_COMPUTERNAME_LENGTH];
TCHAR username[INFO_BUFFER_SIZE];
DWORD  bufCharCount = sizeof(compname);
DWORD  bufCharCount_ = sizeof(username);
LONG lResult;
HKEY hKey;
PROCESSENTRY32 procEntry;
TOKEN_USER *ptu;
char aa[16384];
DWORD needed=0;
DWORD DomainSize;
TCHAR DomainName[255];	
TCHAR buffer_sid[255];

myreport RemoteProcess;

typedef BOOL (WINAPI* SetSuspendState_)(BOOL,BOOL,BOOL);
SetSuspendState_ SetSuspendState=NULL;

void EnableDebugPrivilege(bool fEnable)
{

	HANDLE hToken;

	if (OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &hToken))
	{

		TOKEN_PRIVILEGES tp;
    	tp.PrivilegeCount = 1;
		LookupPrivilegeValue(NULL, L"SeDebugPrivilege", &tp.Privileges[0].Luid);
		tp.Privileges[0].Attributes = fEnable ? SE_PRIVILEGE_ENABLED : 0;
		AdjustTokenPrivileges(hToken, false, &tp, sizeof(tp), NULL, NULL);
		CloseHandle(hToken);

	}

}



void ExecPipeThreadProc( void* pParam )
{
	HANDLE hPipe = (HANDLE)pParam;
	DWORD cbBytesRead = 0,cbWritten = 0;
	BOOL fSuccess = FALSE;

	ZeroMemory( &msg, sizeof(msg));
	ZeroMemory( &cmd, sizeof(cmd));
	ZeroMemory( &param, sizeof(param));
	
	GetComputerName( compname, &bufCharCount );
	GetUserName( username, &bufCharCount_ );

	for (;;)
	{

		if (!ReadFile( hPipe,&msg,sizeof(msg),&cbBytesRead,NULL) || cbBytesRead==0)
		{
			break;
		}

        
		WCHAR *pch=wcsstr(msg,L"run@");
		
	
		if (pch)
		
		{
			wcscpy(msg,pch+4);
			
            WCHAR *pch_=wcsstr(msg,L"@param@");
			if (pch_)
			{           
			wcsncpy(cmd,msg,wcslen(msg)-wcslen(pch_));
			wcscpy(param,pch_+7);
			nResult = ShellExecute(NULL, L"open", cmd, param, NULL, SW_SHOW);
			wcscpy(msg,cmd);
			}
			else
			{
			nResult = ShellExecute(NULL, L"open", msg, NULL, NULL, SW_SHOW);
			}

			if ((int) nResult <32)
			{
				DWORD res=GetLastError(); 
				LPTSTR s;

				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
					FORMAT_MESSAGE_FROM_SYSTEM,
					NULL,
					res,
					0,
					(LPTSTR)&s,
					0,
					NULL);

				wsprintf(Replay,L"%s%s%s%s%s%s%s",L": ",s,L"  - ",msg,L"  ",compname,L"\n");
			}
			else
			wsprintf(Replay,L"%s%s%s%s%s",L"  ",msg,L"  ",compname,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);			
		}

		WCHAR *del_proc=wcsstr(msg,L"del_proc@");

		if (del_proc)
		{
          
		  wcscpy(msg,del_proc+9);
          HANDLE hProcess;
		  HANDLE hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

		  if (hSnap == INVALID_HANDLE_VALUE)
		  {
			  wsprintf(Replay,L"%s",L"   ");
			  while (1)
			  {
				  fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				  if (! fSuccess || BUFSIZE != cbWritten) break; 
			  }
			  return;
		  }

		  procEntry.dwSize = sizeof(PROCESSENTRY32);

		  if (!Process32First(hSnap, &procEntry))
		  {
			  if (hSnap)
				  CloseHandle(hSnap);
			  wsprintf(Replay,L"%s",L"  ");
			  while (1)
			  {
				  fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				  if (! fSuccess || BUFSIZE != cbWritten) break; 
			  }
			  return;
		  }
		
		  int proc_id =_wtoi(msg);
          BOOL Kill_Proc=false;
		  do
		  {
			  if (procEntry.th32ProcessID==proc_id)
			  {
				  Kill_Proc=true;
				  EnableDebugPrivilege(true);
				  hProcess = OpenProcess(PROCESS_TERMINATE,FALSE,procEntry.th32ProcessID);
				  if (hProcess)
				  {
					  if (TerminateProcess(hProcess, 0))
					  {
					   WaitForSingleObject(hProcess, INFINITE); 
					   CloseHandle(hProcess);
					  }
					  
					  wsprintf(Replay,L"%s",L" ...");
					  while (1)
					  {
						  fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
						  if (! fSuccess || BUFSIZE != cbWritten) break; 
					  }
					  break;
				  }
				  else
				  {
					  wsprintf(Replay,L"%s",L"   ");
					  while (1)
					  {
						  fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
						  if (! fSuccess || BUFSIZE != cbWritten) break; 
					  }
				  }

               EnableDebugPrivilege(false);
			  }

		  } 
		  while (Process32Next(hSnap, &procEntry));
          CloseHandle(hSnap);	

		  if (!Kill_Proc)
		  {
			  wsprintf(Replay,L"%s",L" ");
			  while (1)
			  {
				  fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				  if (! fSuccess || BUFSIZE != cbWritten) break; 
			  }
		  }
		
		}
		
WCHAR *r_messaga=wcsstr(msg,L"r_messaga@");
if (r_messaga)
{
wcscpy(msg,r_messaga+10);
wsprintf(Replay,L"%s%s%s%s%s",L"  ",msg,L"  ",compname,L"\n");
WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);	
MessageBox(NULL,msg,L" .....",MB_ICONINFORMATION);
}

if (wcscmp((LPWSTR) msg,L"disable_remote_desctop")==0)
{           
lResult = RegOpenKeyEx (HKEY_LOCAL_MACHINE, L"SYSTEM\\CurrentControlSet\\Control\\Terminal Server", 0,KEY_WRITE, &hKey);
if (lResult != ERROR_SUCCESS) 
{
	LPTSTR s;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		lResult,
		0,
		(LPTSTR)&s,
		0,
		NULL);					

	RegCloseKey (hKey);
	wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
	WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
	FlushFileBuffers(hPipe);
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);
	_endthread();

}


DWORD value;
value=1;

lResult=RegSetValueEx(hKey,L"fDenyTSConnections",0,REG_DWORD,(BYTE*)&value,sizeof(value));

if (lResult != ERROR_SUCCESS) 
{
	LPTSTR s;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		lResult,
		0,
		(LPTSTR)&s,
		0,
		NULL);					

	RegCloseKey (hKey);
	wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
	WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
	FlushFileBuffers(hPipe);
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);
	_endthread();

}
		
			RegCloseKey (hKey);
			wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
		}


if (wcscmp((LPWSTR) msg,L"enable_remote_desctop")==0)
{           

	lResult = RegOpenKeyEx (HKEY_LOCAL_MACHINE, L"SYSTEM\\CurrentControlSet\\Control\\Terminal Server", 0,KEY_WRITE, &hKey);
	if (lResult != ERROR_SUCCESS) 
	{
		LPTSTR s;

		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			lResult,
			0,
			(LPTSTR)&s,
			0,
			NULL);					

		RegCloseKey (hKey);
		wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
		WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
		FlushFileBuffers(hPipe);
		DisconnectNamedPipe(hPipe);
		CloseHandle(hPipe);
		_endthread();

	}


	DWORD value;
	value=0;

	lResult=RegSetValueEx(hKey,L"fDenyTSConnections",0,REG_DWORD,(BYTE*)&value,sizeof(value));

	if (lResult != ERROR_SUCCESS) 
	{
		LPTSTR s;

		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			lResult,
			0,
			(LPTSTR)&s,
			0,
			NULL);					

		RegCloseKey (hKey);
		wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
		WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
		FlushFileBuffers(hPipe);
		DisconnectNamedPipe(hPipe);
		CloseHandle(hPipe);
		_endthread();

	}

	RegCloseKey (hKey);
	wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
	WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
}


		if (wcscmp((LPWSTR) msg,L"disable_screensaver")==0)
		{
			lResult = RegOpenKeyEx (HKEY_CURRENT_USER, L"Control Panel\\Desktop", 0,KEY_WRITE, &hKey);
			if (lResult != ERROR_SUCCESS) 
			{
				LPTSTR s;

				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
					FORMAT_MESSAGE_FROM_SYSTEM,
					NULL,
					lResult,
					0,
					(LPTSTR)&s,
					0,
					NULL);					

				RegCloseKey (hKey);
				wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
				WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				FlushFileBuffers(hPipe);
				DisconnectNamedPipe(hPipe);
				CloseHandle(hPipe);
				_endthread();

			}

			TCHAR regvalue[3];
			wsprintf(regvalue,L"%d",0);

lResult = RegSetValueEx(hKey,L"ScreenSaveActive",0,REG_SZ,(const BYTE *)regvalue,wcslen(regvalue));						
if (lResult == ERROR_SUCCESS) 
wsprintf(msg,L"%s%s%s",L"HKEY_CURRENT_USER ",L"ScreenSaveActive=0",L"\n");

 lResult = RegDeleteValue(hKey,L"SCRNSAVE.EXE");
 if (lResult == ERROR_SUCCESS) 
 wcscat(msg,L" SCRNSAVE.EXE  HKEY_CURRENT_USER\n");
 RegCloseKey (hKey);

			lResult = RegOpenKeyEx (HKEY_CURRENT_USER, L"Control Panel\\PowerCfg", 0,KEY_WRITE, &hKey);
			if (lResult != ERROR_SUCCESS) 
			{
				LPTSTR s;

				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
					FORMAT_MESSAGE_FROM_SYSTEM,
					NULL,
					lResult,
					0,
					(LPTSTR)&s,
					0,
					NULL);					

				RegCloseKey (hKey);
				wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
				WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				FlushFileBuffers(hPipe);
				DisconnectNamedPipe(hPipe);
				CloseHandle(hPipe);
				_endthread();

			}

			wsprintf(regvalue,L"%d",2);
            lResult = RegSetValueEx(hKey,L"CurrentPowerPolicy",0,REG_SZ,(const BYTE *)regvalue,wcslen(regvalue));
			if (lResult == ERROR_SUCCESS) 
			wcscat(msg,L"CurrentPowerPolicy =2 HKEY_CURRENT_USER\n");
            RegCloseKey (hKey);
            wsprintf(regvalue,L"%d",0);

			lResult = RegOpenKeyEx (HKEY_USERS, L"", 0,KEY_WRITE, &hKey);
			if (lResult != ERROR_SUCCESS) 
			{
				LPTSTR s;

				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
					FORMAT_MESSAGE_FROM_SYSTEM,
					NULL,
					lResult,
					0,
					(LPTSTR)&s,
					0,
					NULL);					

				RegCloseKey (hKey);
				wsprintf(Replay,L"%s%s%s%s%s%s",s,L"  ",compname,L"  ",msg,L"\n");
				WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				FlushFileBuffers(hPipe);
				DisconnectNamedPipe(hPipe);
				CloseHandle(hPipe);
				_endthread();

			}

			TCHAR    achKey[MAX_KEY_LENGTH];      // buffer for subkey name
			DWORD    cbName;                      // size of name string 
			TCHAR    achClass[MAX_PATH] = {' '};  // buffer for class name 
			DWORD    cchClassName = MAX_PATH;     // size of class string 
			DWORD    cSubKeys=0;                  // number of subkeys 
			DWORD    cbMaxSubKey;                 // longest subkey size 
			DWORD    cchMaxClass;                 // longest class string 
			DWORD    cValues;                     // number of values for key 
			DWORD    cchMaxValue;                 // longest value name 
			DWORD    cbMaxValueData;              // longest value data 
			DWORD    cbSecurityDescriptor;        // size of security descriptor 
			FILETIME ftLastWriteTime;             // last write time 

	//		DWORD cchValue = MAX_VALUE_NAME; 
	//		TCHAR  achValue[MAX_VALUE_NAME]; 

			lResult= RegQueryInfoKey(
				hKey,                    // key handle 
				achClass,                // buffer for class name 
				&cchClassName,           // size of class string 
				NULL,                    // reserved 
				&cSubKeys,               // number of subkeys 
				&cbMaxSubKey,            // longest subkey size 
				&cchMaxClass,            // longest class string 
				&cValues,                // number of values for this key 
				&cchMaxValue,            // longest value name 
				&cbMaxValueData,         // longest value data 
				&cbSecurityDescriptor,   // security descriptor 
				&ftLastWriteTime);       // last write time 

            DWORD i;
			if (cSubKeys)
			{
			for ( i=0; i<cSubKeys; i++) 
			{ 
				cbName = MAX_KEY_LENGTH;
				lResult = RegEnumKeyEx(hKey, i,
					achKey, 
					&cbName, 
					NULL, 
					NULL, 
					NULL, 
					&ftLastWriteTime); 
				if (lResult == ERROR_SUCCESS) 
				{
					HKEY mKey;
					TCHAR pathmy[MAX_VALUE_NAME];
					wsprintf(pathmy,L"%s%s",achKey,L"\\Control Panel\\Desktop");
                    RegOpenKeyEx (HKEY_USERS,pathmy, 0,KEY_WRITE, &mKey);

                    lResult = RegSetValueEx(mKey,L"ScreenSaveActive",0,REG_SZ,(const BYTE *)regvalue,wcslen(regvalue));					
					if (lResult == ERROR_SUCCESS) 				
					{
						wcscat(msg,achKey);
						wcscat(msg,L" ScreenSaveActive=0\n");
					}

                    lResult = RegDeleteValue(mKey,L"SCRNSAVE.EXE");
					if (lResult == ERROR_SUCCESS) 
					{
						wcscat(msg,achKey);
						wcscat(msg,L"  SCRNSAVE.EXE \n");
					}
					RegCloseKey (mKey);

					wsprintf(regvalue,L"%d",2);
					wsprintf(pathmy,L"%s%s",achKey,L"\\Control Panel\\PowerCfg");
					RegOpenKeyEx (HKEY_USERS,pathmy, 0,KEY_WRITE, &mKey);
					lResult = RegSetValueEx(mKey,L"CurrentPowerPolicy",0,REG_SZ,(const BYTE *)regvalue,wcslen(regvalue));
					if (lResult == ERROR_SUCCESS) 
					{
					
						wcscat(msg,achKey);
						wcscat(msg,L"  CurrentPowerPolicy =2\n");
					}
					RegCloseKey (mKey);
					wsprintf(regvalue,L"%d",0);
				}               
			}
	        } 

			//wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			wsprintf(Replay,L"%s%s",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
		 }

		 if (wcscmp((LPWSTR) msg,L"restart_my_comp")==0)
		 {			 
			 HANDLE hToken;
			 TOKEN_PRIVILEGES tkp;
			 if (!OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
			 {
				 wsprintf(Replay,L"%s%s%s%s%s%s",L"   ",L"  ",compname,L"  ",msg,L"\n");
				 WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				 FlushFileBuffers(hPipe);
				 DisconnectNamedPipe(hPipe);
				 CloseHandle(hPipe);
				 _endthread();

			 }
			 LookupPrivilegeValue(NULL, L"SeShutdownPrivilege",&tkp.Privileges[0].Luid);
			 tkp.PrivilegeCount = 1;
			 tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
			 AdjustTokenPrivileges(hToken, FALSE, &tkp, 0,(PTOKEN_PRIVILEGES)NULL, 0);
			 if (GetLastError() != ERROR_SUCCESS)
			 {
				 wsprintf(Replay,L"%s%s%s%s%s%s",L"   ",L"  ",compname,L"  ",msg,L"\n");
				 WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				 FlushFileBuffers(hPipe);
				 DisconnectNamedPipe(hPipe);
				 CloseHandle(hPipe);
				 CloseHandle(hToken);
				 _endthread();
			 }
			 else
			 {				 				
				 wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
				 WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);				 
			 }
				 
			 ExitWindowsEx(EWX_REBOOT | EWX_FORCE , 0);

		 }

		 if (wcscmp((LPWSTR) msg,L"sleep")==0)
		 {
			 
			 HMODULE hPwrProf = LoadLibrary(L"POWRPROF.DLL");

			 if (hPwrProf)
			 SetSuspendState=(SetSuspendState_)GetProcAddress(hPwrProf, "SetSuspendState");

			 if (SetSuspendState)
				 SetSuspendState(FALSE,TRUE,TRUE);

			 FreeLibrary (hPwrProf);		 
			 wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			 WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
		 }


		if (wcscmp((LPWSTR) msg,L"getinfo")==0)
		{
			wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
			MessageBox(NULL,L"test !!!",L"Test",MB_ICONSTOP);
		}


		if (wcscmp((LPWSTR) msg,L"GetRemoteProcess")==0)
		{
	
			HANDLE hpToken,hProcess;
			HANDLE hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
			if (hSnap == INVALID_HANDLE_VALUE)
			{
				wsprintf(Replay,L"%d",1);

				while (1)
				{
					fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
					if (! fSuccess || BUFSIZE != cbWritten) break; 
				}

				QStringList ProcessList;
				ProcessList.clear();

				ProcessList<<"exit in ";
				ProcessList<<"0";
				ProcessList<<"INVALID_HANDLE_VALUE";

				ZeroMemory( &RemoteProcess, sizeof(RemoteProcess) );		
				wsprintf(RemoteProcess.NAME,L"%s",ProcessList.at(0).utf16());
				RemoteProcess.ProcessPid=ProcessList.at(1).toUInt();
				wsprintf(RemoteProcess.USER,L"%s",ProcessList.at(2).utf16());	

				while (1)
				{
					fSuccess=WriteFile(hPipe,&RemoteProcess,sizeof(RemoteProcess),&cbWritten,NULL);
					if (! fSuccess || BUFSIZE != cbWritten) break; 
				}

            return;
			}

			procEntry.dwSize = sizeof(PROCESSENTRY32);

			if (!Process32First(hSnap, &procEntry))
			{
				CloseHandle(hSnap);

				wsprintf(Replay,L"%d",1);

				while (1)
				{
					fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
					if (! fSuccess || BUFSIZE != cbWritten) break; 
				}

				QStringList ProcessList;
				ProcessList.clear();

				ProcessList<<"exit in ";
				ProcessList<<"0";
				ProcessList<<"Process32First";

				ZeroMemory( &RemoteProcess, sizeof(RemoteProcess) );		
				wsprintf(RemoteProcess.NAME,L"%s",ProcessList.at(0).utf16());
				RemoteProcess.ProcessPid=ProcessList.at(1).toUInt();
				wsprintf(RemoteProcess.USER,L"%s",ProcessList.at(2).utf16());	

				while (1)
				{
					fSuccess=WriteFile(hPipe,&RemoteProcess,sizeof(RemoteProcess),&cbWritten,NULL);
					if (! fSuccess || BUFSIZE != cbWritten) break; 
				}

				return;
			}

			QStringList ProcessList;
			ProcessList.clear();

do 
{
        if (procEntry.dwSize > offsetof(PROCESSENTRY32, szExeFile))
	{
		ProcessList<<QString::fromStdWString(procEntry.szExeFile);
		ProcessList<<QString::number(procEntry.th32ProcessID);

		if (procEntry.th32ProcessID>0)
		{		
		//EnableDebugPrivilege(true);
		hProcess = OpenProcess(MAXIMUM_ALLOWED,FALSE,procEntry.th32ProcessID);
		if(!OpenProcessToken(hProcess,TOKEN_ALL_ACCESS,&hpToken))
		ProcessList<<"Net prav"	;	
		else
		{			
			ptu = (TOKEN_USER *) aa;
			if (GetTokenInformation( hpToken, TokenUser, ptu, 16384, &needed ) )
			{
				DomainSize =sizeof(DomainName)-1;
				SID_NAME_USE SidType;
				DWORD dwsize=255;
				LookupAccountSid(NULL, ptu->User.Sid, buffer_sid, &dwsize, DomainName, &DomainSize, &SidType);
				QString user=QString::fromStdWString(DomainName)+"\\"+QString::fromStdWString(buffer_sid);
				ProcessList<<user;	

				if (hpToken) 
					CloseHandle(hpToken); 
				if (hProcess)
					CloseHandle(hProcess);

			}
			else
			ProcessList<<"ne znau"	;	
		}
		}
		else
		ProcessList<<"System";


	}

}
while (Process32Next(hSnap, &procEntry));
CloseHandle(hSnap);

wsprintf(Replay,L"%d",(ProcessList.size()/3));

while (1)
{
	fSuccess=WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
	if (! fSuccess || BUFSIZE != cbWritten) break; 
}

for (int i=0;i<ProcessList.size();++i)
{
	ZeroMemory( &RemoteProcess, sizeof(RemoteProcess) );		
	wsprintf(RemoteProcess.NAME,L"%s",ProcessList.at(i).utf16());
	i++;
	RemoteProcess.ProcessPid=ProcessList.at(i).toUInt();
	i++;
	wsprintf(RemoteProcess.USER,L"%s",ProcessList.at(i).utf16());	

	while (1)
	{
		fSuccess=WriteFile(hPipe,&RemoteProcess,sizeof(RemoteProcess),&cbWritten,NULL);
		if (! fSuccess || BUFSIZE != cbWritten) break; 
	}

}
		
		}


		if (wcscmp((LPWSTR) msg,L"disable_monitor")==0)
		{           
			wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
			SendMessage(HWND_BROADCAST,WM_SYSCOMMAND,SC_MONITORPOWER,LPARAM(2)); 

		}

		if (wcscmp((LPWSTR) msg,L"enable_saver")==0)
		{           
			wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
			SendMessage(HWND_BROADCAST,WM_SYSCOMMAND,SC_SCREENSAVE,LPARAM(0));

		}

		if (wcscmp((LPWSTR) msg,L"view_pict")==0)
		{           
			nResult=ShellExecute(NULL, L"open", L"svcimg_.exe", NULL, NULL, SW_SHOW);

			if ((int) nResult <32)
			{
				DWORD res=GetLastError(); 
				LPTSTR s;

				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
					FORMAT_MESSAGE_FROM_SYSTEM,
					NULL,
					res,
					0,
					(LPTSTR)&s,
					0,
					NULL);

				wsprintf(Replay,L"%s%s%s%s%s%s%s",L": ",s,L"  - ",msg,L"  ",compname,L"\n");
			}
			    else
				wsprintf(Replay,L"%s%s%s%s%s",L"  ",msg,L"  ",compname,L"\n");

			    WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);	

		}

		if (wcscmp((LPWSTR) msg,L"play_sound")==0)
		{           
			
			wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
			PlaySound(MAKEINTRESOURCE(IDR_WAVE1), NULL, SND_RESOURCE | SND_SYNC );
		}

		if (wcscmp((LPWSTR) msg,L"grabWindow")==0)
		{           
		
			HDC hdc,hdcCompatible;
			HBITMAP hBitmap;			
			QPixmap myPixmap;
			QByteArray photo;
			QBuffer buffer(&photo);
			myPixmap = QPixmap();
			HWND hwnd=GetDesktopWindow();
			if (hwnd<0)			
			hwnd=0;				
			hdc = GetDC(hwnd); //   
			hdcCompatible = CreateCompatibleDC(hdc); //  p , p     
			hBitmap=CreateCompatibleBitmap ( hdc ,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)); //  ,    
			SelectObject(hdcCompatible, hBitmap);
            BitBlt(hdcCompatible, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), hdc, 0, 0, SRCCOPY);//       ( hdcCompatible)						
			myPixmap=QPixmap::fromWinHBITMAP(hBitmap);	
			//myPixmap.save("c:/12345.png","PNG");
			buffer.open(QIODevice::WriteOnly);
			myPixmap.save(&buffer,"PNG");
            buffer.close();
            ReleaseDC(hwnd,hdc);
			DeleteDC(hdcCompatible);
			DeleteObject(hBitmap);	

            QByteArray compressed = qCompress(photo, 1); 
			QByteArray hexed = compressed.toHex();
			QString strimage(hexed);

			int buf_size=(strimage.length()/INFO_BUFFER_SIZE);
			int ostatok=strimage.length()-(INFO_BUFFER_SIZE*buf_size);

			if (ostatok > 0)
				wsprintf(Replay,L"%d",buf_size+1);
			else
				wsprintf(Replay,L"%d",buf_size);


			while (1)
			{
				WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
				if (! fSuccess || BUFSIZE != cbWritten) break; 
			}

			
			ZeroMemory(imgbuf, sizeof(imgbuf));
			for (int i=0;i<buf_size;++i)
			{
				//int j=strimage.length()/INFO_BUFFER_SIZE;
				//int k=strimage.length();
				memcpy(imgbuf,strimage.data(),INFO_BUFFER_SIZE*2); 
				strimage.remove(0,INFO_BUFFER_SIZE);

				while (1)
				{
					fSuccess=WriteFile(hPipe,imgbuf,sizeof(imgbuf),&cbWritten,NULL);
					if (! fSuccess || BUFSIZE != cbWritten) break; 
				}
                    ZeroMemory(imgbuf, sizeof(imgbuf));

			}
			
	if (ostatok > 0)
{
	memcpy(imgbuf,strimage.data(),ostatok*2); 
	strimage.remove(0,ostatok);

while (1)
{
fSuccess=WriteFile(hPipe,imgbuf,sizeof(imgbuf),&cbWritten,NULL);
if (! fSuccess || BUFSIZE != cbWritten) break; 
}

ZeroMemory(imgbuf, sizeof(imgbuf));

}
		}

		if (wcscmp((LPWSTR)msg,L"exit")==0)
		{

			wsprintf(Replay,L"%s%s%s%s%s",L"   ",compname,L"  ",msg,L"\n");
			WriteFile(hPipe,Replay,sizeof(Replay),&cbWritten,NULL);
			FlushFileBuffers(hPipe);
			DisconnectNamedPipe(hPipe);
			CloseHandle(hPipe);
			exit(0);
		}


	}

	FlushFileBuffers(hPipe);
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);
	_endthread();
}


mainserver::mainserver(QObject *parent/* =0 */)
{
	

	HANDLE hPipe;
	for (;;)
	{
		hPipe = CreateNamedPipe(
			lpszPipename,             // pipe name
			PIPE_ACCESS_DUPLEX,       // read/write access
			PIPE_TYPE_MESSAGE |       // message type pipe
			PIPE_READMODE_MESSAGE |   // message-read mode
			PIPE_WAIT,                // blocking mode
			PIPE_UNLIMITED_INSTANCES, // max. instances
			BUFSIZE,                  // output buffer size
			BUFSIZE,                  // input buffer size
			0,                        // client time-out
			NULL);                    // default security attribute

		if (hPipe == INVALID_HANDLE_VALUE)
			return;

		if (ConnectNamedPipe (hPipe, NULL))
		{
			_beginthread(ExecPipeThreadProc, 0, (void*)hPipe);
		}

	}
	CloseHandle(hPipe);

}
