#define UNICODE
#define BUFSIZE 4096
#pragma comment(linker,"/ENTRY:main")

#include <windows.h>
#include <process.h>
#include <tchar.h>
#include <stdio.h>



LPTSTR lpszPipename = L"\\\\.\\pipe\\mynamedpipe";

void ExecPipeThreadProc( void* pParam )
{
	HANDLE hPipe = (HANDLE)pParam;
	TCHAR msg[0x1000];
	DWORD cbBytesRead = 0,cbWritten = 0;
	BOOL fSuccess = FALSE;
	ZeroMemory( &msg, sizeof(msg));
    TCHAR Replay[0x1000];
	TCHAR  infoBuf[MAX_COMPUTERNAME_LENGTH];
	DWORD  bufCharCount = sizeof(infoBuf);


	for (;;)
	{

		if (!ReadFile( hPipe,&msg,sizeof(msg),&cbBytesRead,NULL) || cbBytesRead==0)
		{
			break;
		}
		GetComputerName( infoBuf, &bufCharCount );
		wsprintf(Replay,L"%s%s%s%s%s",L"RESPONSE ",infoBuf,L". command ",msg,L"\n");

		WriteFile(
			hPipe,        // handle to pipe
			Replay,      // buffer to write from
			sizeof(Replay), // number of bytes to write
			&cbWritten,   // number of bytes written
			NULL);        // not overlapped I/O

		if (wcscmp((LPWSTR) msg,L"test")==0)
		{
			//MessageBox(NULL,_T("test !!!"),_T("Test"),MB_ICONSTOP);
		}


		if (wcscmp((LPWSTR) msg,L"disable_monitor")==0)
		{           
			SendMessage(HWND_BROADCAST,WM_SYSCOMMAND,SC_MONITORPOWER,LPARAM(2)); 
		}
	
		if (wcscmp((LPWSTR) msg,L"enable_saver")==0)
		{           
			SendMessage(HWND_BROADCAST,WM_SYSCOMMAND,SC_SCREENSAVE,LPARAM(0));
	
		}


		if (wcscmp((LPWSTR)msg,L"exit")==0)
		{
			FlushFileBuffers(hPipe);
			DisconnectNamedPipe(hPipe);
			CloseHandle(hPipe);
			exit(0);
		}


	}
	
	FlushFileBuffers(hPipe);
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);
	_endthread();
}

int main()
{
	HANDLE hPipe;
	for (;;)
	{
		hPipe = CreateNamedPipe(
			lpszPipename,             // pipe name
			PIPE_ACCESS_DUPLEX,       // read/write access
			PIPE_TYPE_MESSAGE |       // message type pipe
			PIPE_READMODE_MESSAGE |   // message-read mode
			PIPE_WAIT,                // blocking mode
			PIPE_UNLIMITED_INSTANCES, // max. instances
			BUFSIZE,                  // output buffer size
			BUFSIZE,                  // input buffer size
			0,                        // client time-out
			NULL);                    // default security attribute

		if (hPipe == INVALID_HANDLE_VALUE)
			return (0);

		if (ConnectNamedPipe (hPipe, NULL))
		{
			_beginthread(ExecPipeThreadProc, 0, (void*)hPipe);
		}

	}
	CloseHandle(hPipe);
	return (0);
}

