#include "get_comp.h"
#include <shlobj.h>
#include <QMenu>



get_my_comp::get_my_comp(QWidget *parent)
: QDialog(parent)
{
	setupUi(this);
}

get_my_comp::~get_my_comp()
{
}

void get_my_comp::GetRemoteComp(LPWSTR* CompName)
{
	BROWSEINFO    info;
	LPITEMIDLIST  pidl,pidlIN;
	LPMALLOC      pShellMalloc;
	TCHAR szDisplay[MAX_PATH],szDir[MAX_PATH]; 
	HRESULT hr;

	hr=SHGetSpecialFolderLocation(NULL, CSIDL_NETWORK, &pidlIN); 

	if (hr!=S_OK )
		return;

	if(SHGetMalloc(&pShellMalloc) == NO_ERROR)
	{
		ZeroMemory(&info, sizeof(info));
		ZeroMemory(&szDisplay, sizeof(szDisplay));
		ZeroMemory(&szDir, sizeof(szDir));			

		info.hwndOwner=NULL;
		info.pidlRoot  = pidlIN;                     
		info.pszDisplayName = szDisplay;     
		info.lpszTitle = L" :";         
		info.ulFlags   = BIF_BROWSEFORCOMPUTER;   
		info.lpfn = NULL;        

		pidl=SHBrowseForFolder(&info);
		if (pidl)
		{
			pShellMalloc->Free(pidl);
		}
		pShellMalloc->Free(pidlIN);
		pShellMalloc->Release();
	}

	*CompName=szDisplay;
//	remComp=QString::fromStdWString(*CompName);
}

void get_my_comp::on_pushButton_2_clicked()
{
	lineEdit->clear();
	LPWSTR Di;
	GetRemoteComp(&Di);
    if (wcslen(Di)!=0)
    lineEdit->setText(QString::fromStdWString(Di))	;
}

void get_my_comp::on_pushButton_clicked()
{
	if (lineEdit->text()!="")
	{
		QListWidgetItem *newItem = new QListWidgetItem;
		newItem->setText(lineEdit->text());
		listWidget->insertItem(0, newItem);
		lineEdit->clear();
	}
	
}


void get_my_comp::on_pushButton_3_clicked()
{
	CompList.clear();
	QListWidgetItem *newItem = new QListWidgetItem;
	for (int i=0;i<listWidget->count();i++)
	{
	newItem=listWidget->item(i);
	CompList<<newItem->text();
	}
	delete newItem;
	close();
}

void get_my_comp::on_listWidget_customContextMenuRequested(QPoint)
{
	QMenu menu(this);
	QAction *action1 = menu.addAction("");
	QAction *triggered = menu.exec(QCursor::pos());

	if (triggered == action1)
	delete listWidget->currentItem();
}
