
#define BUFSIZE 512
#define INFO_BUFFER_SIZE 32767
#define SERVICENAME   L"r_srv"

#include "remote_assistant.h"
#include <shlobj.h>
#include <atlconv.h>
#include <lm.h>
#include <windows.h>
#include <initguid.h>
#include <mstask.h>
#include "mainimage.h"
#include "my_process.h"
#include "remote_process.h"
#include "get_comp.h"
#include <qplastiquestyle.h>

#pragma comment(lib, "mpr.lib")
#pragma comment(lib, "Netapi32.lib")


remote_assistant::remote_assistant(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	ui.setupUi(this);
	QDir mydir;
//	MyClient->edit_ = findChild<QTextEdit*>("textEdit");
	QApplication::setStyle(new  QPlastiqueStyle);

}

remote_assistant::~remote_assistant()
{

}

void remote_assistant::GetRemoteComp(LPWSTR* CompName)
{
	BROWSEINFO    info;
	LPITEMIDLIST  pidl,pidlIN;
	LPMALLOC      pShellMalloc;
	TCHAR szDisplay[MAX_PATH],szDir[MAX_PATH]; 
	HRESULT hr;

	hr=SHGetSpecialFolderLocation(NULL, CSIDL_NETWORK, &pidlIN); 

	if (hr!=S_OK )
		return;
	
	if(SHGetMalloc(&pShellMalloc) == NO_ERROR)
	{
		ZeroMemory(&info, sizeof(info));
		ZeroMemory(&szDisplay, sizeof(szDisplay));
		ZeroMemory(&szDir, sizeof(szDir));			

		info.hwndOwner=NULL;
		info.pidlRoot  = pidlIN;                     
		info.pszDisplayName = szDisplay;     
		info.lpszTitle = L" :";         
		info.ulFlags   = BIF_BROWSEFORCOMPUTER;   
		info.lpfn = NULL;        

		pidl=SHBrowseForFolder(&info);
		if (pidl)
		{
			pShellMalloc->Free(pidl);
		}
		pShellMalloc->Free(pidlIN);
		pShellMalloc->Release();
	}

*CompName=szDisplay;
//remComp=QString::fromStdWString(*CompName);
}


bool remote_assistant::CopyFiles(QString in_,QString out_)
{
    if ( QFile::copy(in_,out_))
		return true;
     else 
{
      if (QFile::remove(out_)) 
   {
       if  ( QFile::copy(in_,out_))
       return true;
       else
       return false;
    }
      else
      return false;
}}

bool remote_assistant::ConnectRemoteComp(LPWSTR ComputerName,LPWSTR Resource, 
										 LPWSTR lpszPassword, LPWSTR lpszUser,int countcopy)
{
	QDir mydir;
    QString RemoteRes,RemoteRes_;	
	PSHARE_INFO_1 BufPtr,p;

	DWORD rc,er=0,tr=0,resume=0,i;
	RemoteRes=QString::fromStdWString (ComputerName)+"\\"+QString::fromStdWString (Resource);

	NETRESOURCE nr;
	nr.dwType = RESOURCETYPE_ANY;
	nr.lpLocalName = NULL;
	nr.lpRemoteName = LPWSTR(RemoteRes.utf16());
	nr.lpProvider = NULL;

rc = WNetAddConnection2( &nr, lpszPassword, lpszUser, FALSE );
if ( rc != NO_ERROR )
{
	rc = NetShareEnum (ComputerName, 1, (LPBYTE *) &BufPtr, -1, &er, &tr, &resume);
	if(rc == NERR_Success)
	{
		p=BufPtr;
		for(i=1;i<=er;i++)
		{
			RemoteRes_=QString::fromStdWString (ComputerName)+"\\"+QString::fromStdWString (p->shi1_netname);
			rc=WNetCancelConnection2(LPWSTR(RemoteRes_.utf16()), CONNECT_UPDATE_PROFILE, TRUE);
			p++;
		}
		NetApiBufferFree(BufPtr);
		rc = WNetAddConnection2( &nr, lpszPassword, lpszUser, FALSE );
		if ( rc != NO_ERROR )
		{													
         LPTSTR s;
         FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |FORMAT_MESSAGE_FROM_SYSTEM,NULL,rc,0,(LPTSTR)&s,0,NULL);
         MessageBox(NULL,s,L"ERROR",MB_ICONSTOP);
         return false;																
		}	

	}
	else
	{
		ui.textEdit->textCursor().insertText("   \n");
		return false;
	}
}
rc = NetShareEnum (ComputerName, 1, (LPBYTE *) &BufPtr, -1, &er, &tr, &resume);
if(rc == NERR_Success)
{
	p=BufPtr;
	for(i=1;i<=er;i++)
	{
		if (countcopy !=0)
		{
			RemoteRes_=QString::fromStdWString (ComputerName)+"\\"+QString::fromStdWString (p->shi1_netname);
			ui.textEdit->textCursor().insertText(QString::fromStdWString(p->shi1_netname)+"\n");
		}
		p++;
	}
	NetApiBufferFree(BufPtr);
}
else
{
	
	ui.textEdit->textCursor().insertText("   \n");
}

if (countcopy==1)
{
if ( ! CopyFiles(mydir.absolutePath()+"/svchosts.exe",RemoteRes+"\\svchosts.exe"))
MessageBox(NULL,L"svchosts.exe   .   .",L"ERROR",MB_ICONSTOP);
else
ui.textEdit->textCursor().insertText("svchosts.exe \n");

if ( ! CopyFiles(mydir.absolutePath()+"/psvchosts.exe",RemoteRes+"\\psvchosts.exe"))
MessageBox(NULL,L"psvchosts.exe  .   .",L"ERROR",MB_ICONSTOP);
else
ui.textEdit->textCursor().insertText("psvchosts.exe \n");

if ( ! CopyFiles(mydir.absolutePath()+"/svcimg_.exe",RemoteRes+"\\svcimg_.exe"))
MessageBox(NULL,L"svcimg_.exe    .   .",L"ERROR",MB_ICONSTOP);
else
ui.textEdit->textCursor().insertText("svcimg_.exe   \n");

if ( ! CopyFiles(mydir.absolutePath()+"/r_loader.exe",RemoteRes+"\\r_loader.exe"))
MessageBox(NULL,L"r_loader.exe   .   .",L"ERROR",MB_ICONSTOP);
else
ui.textEdit->textCursor().insertText("r_loader.exe  \n");
WNetCancelConnection2( LPWSTR(RemoteRes.utf16()), 0, NULL );
}

return true;
}


void remote_assistant::on_pushButton_5_clicked()
	{
		HRESULT hr = S_OK;
        ITask *pITask=NULL;
		LPCWSTR lpcwszTaskName;
		ITaskScheduler *pITS;
		LPCWSTR ojob=L"R_SERVER_EXEC";
		IPersistFile *pIPersistFile;
		DWORD dwTaskFlags;
		WORD wTrigNumber; 
		ITaskTrigger *pITaskTrig=NULL;
	
		TCHAR CompName[MAX_PATH];
		//LPWSTR Di;
		//GetRemoteComp(&Di);
		wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());
		if (wcslen(CompName)>2)
		 {
if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);

hr = CoInitialize(NULL);
if (SUCCEEDED(hr))
{			
hr = CoCreateInstance(CLSID_CSchedulingAgent,NULL,CLSCTX_INPROC_SERVER,IID_ITaskScheduler,(void **) &pITS);
hr=pITS->SetTargetComputer(BSTR(CompName));
if (FAILED(hr))     
{
	CoUninitialize();

	LPTSTR s;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		hr,
		0,
		(LPTSTR)&s,
		0,
		NULL);

	MessageBox(NULL,s,L"ERROR",MB_ICONSTOP);
	if (pITS) pITS->Release();
	return;
}
hr = pITS->Delete(ojob);
hr = pITS->NewWorkItem(ojob,CLSID_CTask,IID_ITask,(IUnknown**)&pITask);
pITS->Release(); 
if (FAILED(hr))     
{
	CoUninitialize();
	MessageBox(NULL,L"Error:  create new task failure",L"Error",MB_ICONSTOP);   
	if (pITask) pITask->Release();
	return;
}
hr = pITask->QueryInterface(IID_IPersistFile,(void **)&pIPersistFile);
if (FAILED(hr))
{
	CoUninitialize();
	MessageBox(NULL,L"  ",L"Error",MB_ICONSTOP);  
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	return ;
}

//hr = pITask->SetAccountInformation(BSTR(ui.lineEdit->text().utf16()),BSTR(ui.lineEdit_2->text().utf16()));  
hr = pITask->SetAccountInformation(L"",NULL);  
if(FAILED(hr))
{         
		
	LPTSTR s;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		hr,
		0,
		(LPTSTR)&s,
		0,
		NULL);


	MessageBox(NULL,s,L"ERROR",MB_ICONSTOP);

	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	CoUninitialize();
	return;
}

hr = pITask->SetApplicationName(L"r_loader.exe");

if (FAILED(hr))     
{
	MessageBox(NULL,L"    ",L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	CoUninitialize();
	return;
}


QString param;
param="psvchosts.exe ";

if (ui.lineEdit_7->text()!= "")
param=param+ui.lineEdit_7->text();
else
{
	if (ui.lineEdit_3->text()!= "")
		param=param+ui.lineEdit_3->text();
	else
		param=param+"winlogon.exe";
}


LPCWSTR oparams;
oparams=LPCWSTR(param.utf16());

hr = pITask->SetParameters(oparams);  
if (FAILED(hr))     
{
	MessageBox(NULL,L"    ",L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	CoUninitialize();
	return;
}


dwTaskFlags = TASK_FLAG_DELETE_WHEN_DONE | TASK_FLAG_INTERACTIVE ; 
//dwTaskFlags = TASK_FLAG_INTERACTIVE ; 

hr = pITask->SetFlags(dwTaskFlags);
 

if (FAILED(hr))     
{
	MessageBox(NULL,L"   ",L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	CoUninitialize();
	return;
}

hr = pITask->CreateTrigger(&wTrigNumber, &pITaskTrig);  
if (FAILED(hr)) 
{
	MessageBox(NULL,L"  ",L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	CoUninitialize();
	return;
}

TASK_TRIGGER TaskTrig;
ZeroMemory(&TaskTrig, sizeof (TASK_TRIGGER));

TaskTrig.wBeginDay =1;                  // Required
TaskTrig.wBeginMonth =1;                // Required
TaskTrig.wBeginYear =1999;              // Required
TaskTrig.cbTriggerSize = sizeof (TASK_TRIGGER); 
TaskTrig.wStartHour = 13;
TaskTrig.TriggerType = TASK_TIME_TRIGGER_ONCE;
TaskTrig.Type.Daily.DaysInterval = 1;


hr = pITaskTrig->SetTrigger(&TaskTrig);     
if (FAILED(hr))
{
	MessageBox(NULL,L"  ",L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
    if (pITaskTrig)	pITaskTrig->Release();
	CoUninitialize();
	return;


}

hr = pITask->SetCreator(L"SYSTEM");

hr = pIPersistFile->Save(NULL,TRUE);
if (FAILED(hr))
{
	LPTSTR s;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		hr,
		0,
		(LPTSTR)&s,
		0,
		NULL);


	MessageBox(NULL,s,L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	if (pITaskTrig)	pITaskTrig->Release();
	CoUninitialize();


	return;
}

hr=pITask->Run() ;
if (FAILED(hr)) 
{
	MessageBox(NULL,L"  ",L"ERROR",MB_ICONSTOP);
	if (pITask) pITask->Release();
	if (pIPersistFile) pIPersistFile->Release();
	if (pITaskTrig)	pITaskTrig->Release();
	CoUninitialize();
}
else
ui.textEdit->textCursor().insertText("  \n");

if (pITask) pITask->Release();
if (pIPersistFile) pIPersistFile->Release();
if (pITaskTrig)	pITaskTrig->Release();
CoUninitialize();
}


wcscat(CompName,L"\\IPC$");
WNetCancelConnection2(CompName, 0, NULL );

}

	}


	void remote_assistant::SetCommand(LPTSTR command,LPTSTR compname)
	{
     bool fSuccess; 
	 HANDLE hPipe; 
	 TCHAR lpszPipename[MAX_PATH];
	 DWORD cbRead, cbWritten, dwMode; 
	 TCHAR msg[0x1000];
	 //TCHAR msg[INFO_BUFFER_SIZE];
	 ZeroMemory( &msg, sizeof(msg));
	 wsprintf( lpszPipename,L"%s%s%s",L"\\\\",compname,L"\\pipe\\my_pipe_server_");
      while (1) 
	 { 
		 hPipe = CreateFile( 
			 lpszPipename,   // pipe name 
			 GENERIC_READ |  // read and write access 
			 GENERIC_WRITE, 
			 0,              // no sharing 
			 NULL,           // default security attributes
			 OPEN_EXISTING,  // opens existing pipe 
			 0,              // default attributes 
			 NULL);          // no template file 


		 if (hPipe != INVALID_HANDLE_VALUE) 
		 break; 

		 if (GetLastError() != ERROR_PIPE_BUSY) 
		 {
		 CloseHandle(hPipe); 	
		 //MessageBox(NULL,L"   ",lpszPipename,MB_ICONSTOP);
		 ui.textEdit->textCursor().insertText("   "+QString::fromStdWString(lpszPipename));
         return;
		 }

		 if (!WaitNamedPipe(lpszPipename, 20000)) 
		 {
		 CloseHandle(hPipe); 	
         return;
		 }		 
	 }

 dwMode = PIPE_READMODE_MESSAGE; 

 fSuccess=SetNamedPipeHandleState(hPipe, &dwMode,NULL, NULL);    
 if (!fSuccess) 
 {
 CloseHandle(hPipe); 	
 return;
 }

 fSuccess=WriteFile(hPipe,command,(lstrlen(command)+1)*sizeof(TCHAR),&cbWritten,NULL);
 if (!fSuccess) 
 {
 MessageBox(NULL,L"   ",L"ERROR",MB_ICONSTOP);
 }

 do 
 { 
	 fSuccess = ReadFile( 
		 hPipe,    // pipe handle 
		 msg,    // buffer to receive reply 
		 sizeof(msg),  // size of buffer 
		 &cbRead,  // number of bytes read 
		 NULL);    // not overlapped 

	 if (! fSuccess && GetLastError() != ERROR_MORE_DATA) 
		 break; 

 } 
 while (!fSuccess);  // repeat loop if ERROR_MORE_DATA 


CloseHandle(hPipe); 
ui.textEdit->textCursor().insertText(QString::fromStdWString(msg)+"\n");

	}


void remote_assistant::on_pushButton_clicked()
{

  ui.textEdit->clear();
  TCHAR CompName[MAX_PATH],CompNameSave[MAX_PATH];	
  if (ui.lineEdit_6->text().size()==0)
  {  
  LPWSTR Di;
  GetRemoteComp(&Di);
  wsprintf( CompName,L"%s%s",L"\\\\",Di);
  wsprintf( CompNameSave,L"%s",Di);
  }
  else
  {
	  wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());
	  wsprintf( CompNameSave,L"%s",ui.lineEdit_6->text().utf16());
  }


  if (wcslen(CompName)>2)
  {
	  
      ConnectRemoteComp(CompName,L"ADMIN$",LPWSTR (ui.lineEdit_2->text().utf16()),
	  LPWSTR (ui.lineEdit->text().utf16()),1);
	  ui.lineEdit_6->setText(QString::fromStdWString(CompNameSave));
  }
  
	
}


void remote_assistant::on_pushButton_2_clicked()
{	
TCHAR CompName[MAX_PATH];
if (ui.lineEdit_6->text()!="")
wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());
if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);
SetCommand(L"disable_monitor",(LPWSTR)ui.lineEdit_6->text().utf16());	
wcscat(CompName,L"\\IPC$");
WNetCancelConnection2(CompName, 0, NULL );
}

void remote_assistant::on_pushButton_3_clicked()
{
TCHAR CompName[MAX_PATH];
if (ui.lineEdit_6->text()!="")
wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());
if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);
SetCommand(L"enable_saver",(LPWSTR)ui.lineEdit_6->text().utf16());	
wcscat(CompName,L"\\IPC$");
WNetCancelConnection2(CompName, 0, NULL );
}

void remote_assistant::on_pushButton_4_clicked()
{
	//LPWSTR Di;
	//GetRemoteComp(&Di);
	if (ui.lineEdit_6->text()!="")
	SetCommand(L"exit",(LPWSTR)ui.lineEdit_6->text().utf16());	
}

void remote_assistant::on_pushButton_6_clicked()
{
	TCHAR CompName[MAX_PATH];	
	//LPWSTR Di;
	//GetRemoteComp(&Di);
	//if (wcslen(Di)==0)
	if (ui.lineEdit_6->text()=="")
	return;

	wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());

    if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
	ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);

	SetCommand(L"exit",(LPWSTR)ui.lineEdit_6->text().utf16());	

	SC_HANDLE hSCM = OpenSCManager( CompName, NULL, SC_MANAGER_ALL_ACCESS);

	if (hSCM == NULL)
	{
		MessageBox(NULL,L"    .",L"ERROR",MB_ICONSTOP);
		return;
	}


    SC_HANDLE hService_ =OpenService( hSCM, SERVICENAME, SERVICE_STOP );
	if ( hService_ == NULL )
	{
		MessageBox(NULL,L"  .",L"ERROR",MB_ICONSTOP);
		return;
	}


	SC_HANDLE hService =OpenService( hSCM, SERVICENAME, DELETE );
	if ( hService == NULL )
	{
		MessageBox(NULL,L"  .",L"ERROR",MB_ICONSTOP);
		return;
	}

	if (! DeleteService(hService) ) 
		MessageBox(NULL,L"  .",L"ERROR",MB_ICONSTOP);
	else
		MessageBox(NULL,L"  .",L"OK",MB_ICONINFORMATION);

	CloseServiceHandle(hService_);
	CloseServiceHandle(hService);
	CloseServiceHandle(hSCM);

	wcscat(CompName,L"\\IPC$");
	WNetCancelConnection2(CompName, 0, NULL );

	
}


void remote_assistant::on_pushButton_7_clicked()
{
	TCHAR CompName[MAX_PATH];	
	//LPWSTR Di;
	//GetRemoteComp(&Di);
	if (ui.lineEdit_6->text() !="")
	{			
	wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());

    if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
	ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);	

	SC_HANDLE hSCM = OpenSCManager( CompName, NULL, SC_MANAGER_ALL_ACCESS);

	if (hSCM == NULL)
	{
		MessageBox(NULL,L" .",L"OK",MB_ICONINFORMATION); 
		return;
	}

	SC_HANDLE hService =OpenService( hSCM, SERVICENAME, SERVICE_ALL_ACCESS );
	if ( hService == NULL )
	{

		QString param;
		param=" psvchosts.exe ";

		if (ui.lineEdit_7->text()!= "")
			param=param+ui.lineEdit_7->text();
		else
		{
			if (ui.lineEdit_3->text()!= "")
			param=param+ui.lineEdit_3->text();
			else
			param=param+"winlogon.exe";
		}

		param="%SystemRoot%\\svchosts.exe"+param;

		LPCWSTR oparams;
		oparams=LPCWSTR(param.utf16());


		hService = CreateService(
			hSCM, SERVICENAME, SERVICENAME,
			SERVICE_ALL_ACCESS, 
			SERVICE_WIN32_OWN_PROCESS | SERVICE_INTERACTIVE_PROCESS,
			SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL,
			oparams,
			NULL, NULL, NULL, NULL, NULL );  

		if (hService == NULL)
		{
			CloseServiceHandle(hSCM);
			MessageBox(NULL,L"   .",L"OK",MB_ICONINFORMATION);
			return;
		}


		if ( !StartService( hService, 0, NULL ) )
		{
			MessageBox(NULL,L"   .",L"OK",MB_ICONINFORMATION);
			return;
		}
		else
			MessageBox(NULL,L"  .",L"OK",MB_ICONINFORMATION);

		CloseServiceHandle(hService);
		CloseServiceHandle(hSCM);
}
	else
	{
		if ( !StartService( hService, 0, NULL ) )
		{
			MessageBox(NULL,L"   .",L"OK",MB_ICONINFORMATION);
			return;
		}
		else
			MessageBox(NULL,L"  .",L"OK",MB_ICONINFORMATION);
	}
	wcscat(CompName,L"\\IPC$");
	WNetCancelConnection2(CompName, 0, NULL );

}
}

void remote_assistant::on_pushButton_8_clicked()
{
TCHAR CompName[MAX_PATH];
if (ui.lineEdit_6->text()!="")
{
wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());

if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);

mainimage my_image(this);
my_image.compname=(LPWSTR)ui.lineEdit_6->text().utf16();
my_image.exec();		 		
}
wcscat(CompName,L"\\IPC$");
WNetCancelConnection2(CompName, 0, NULL );
}

void remote_assistant::on_pushButton_9_clicked()
{
if (ui.lineEdit_6->text()=="")
return;
TCHAR CompName[MAX_PATH];

wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());

if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);

    TCHAR mycommand[255];
	if (ui.lineEdit_4->text()!="")
	{
	if (ui.lineEdit_5->text()!="")
	wsprintf(mycommand,L"%s%s%s%s",L"run@",ui.lineEdit_4->text().utf16(),L"@param@",ui.lineEdit_5->text().utf16());
	else
	wsprintf(mycommand,L"%s%s",L"run@",ui.lineEdit_4->text().utf16());
    SetCommand(mycommand,(LPWSTR)ui.lineEdit_6->text().utf16());	
	}	

	wcscat(CompName,L"\\IPC$");
	WNetCancelConnection2(CompName, 0, NULL );

}


void remote_assistant::on_pushButton_10_clicked()
{
	LPWSTR Di;
	WCHAR temp[255];
	if (ui.lineEdit_6->text()=="")
	{
    GetRemoteComp(&Di);
	wcscpy(temp,Di);
	}
	else
	wcscpy(temp,ui.lineEdit_6->text().utf16());
		
    if (wcslen(temp)>0)
	{
	get_process get_my_process;
	wsprintf(get_my_process.compname,L"%s",temp);
    get_my_process.doinit();
	get_my_process.exec();
	ui.lineEdit_3->setText(get_my_process.process_name);
	ui.lineEdit_7->setText(get_my_process.process_pid);
	}
    	
}

void remote_assistant::on_pushButton_11_clicked()
{
if (ui.lineEdit_6->text()!="")
SetCommand(L"enable_remote_desctop",(LPWSTR)ui.lineEdit_6->text().utf16());	
MessageBox(NULL,L"      Windows",L" !",MB_ICONSTOP);
}

void remote_assistant::on_pushButton_12_clicked()
{
if (ui.lineEdit_6->text()!="")
SetCommand(L"disable_remote_desctop",(LPWSTR)ui.lineEdit_6->text().utf16());
MessageBox(NULL,L"      Windows",L" !",MB_ICONSTOP);
}

void remote_assistant::on_pushButton_13_clicked()
{
TCHAR CompName[MAX_PATH];
if (ui.lineEdit_6->text()!="")

wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());
if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);

SetCommand(L"play_sound",(LPWSTR)ui.lineEdit_6->text().utf16());

wcscat(CompName,L"\\IPC$");
WNetCancelConnection2(CompName, 0, NULL );

}

void remote_assistant::on_pushButton_15_clicked()
{
	TCHAR CompNameSave[MAX_PATH];	
	LPWSTR Di;
	GetRemoteComp(&Di);
	wsprintf( CompNameSave,L"%s",Di);

	if (wcslen(CompNameSave)>0)	
	ui.lineEdit_6->setText(QString::fromStdWString(CompNameSave));
}


void remote_assistant::on_pushButton_14_clicked()
{
TCHAR CompName[MAX_PATH];
if (ui.lineEdit_6->text()!="")
{
	
	wsprintf( CompName,L"%s%s",L"\\\\",ui.lineEdit_6->text().utf16());
	if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
	ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);

	get_remote_process my_remote_proc;
	my_remote_proc.compname = (LPWSTR)ui.lineEdit_6->text().utf16();
	my_remote_proc.exec();
}

wcscat(CompName,L"\\IPC$");
WNetCancelConnection2(CompName, 0, NULL );

}


void remote_assistant::on_pushButton_16_clicked()
{
TCHAR mycommand[255];
TCHAR CompName[MAX_PATH];
if (ui.lineEdit_4->text()!="")
{
	get_my_comp get_list_comp;
	get_list_comp.exec();

	for (int i=0;i<get_list_comp.CompList.size();i++)
	{
		if (ui.lineEdit_5->text()!="")
		wsprintf(mycommand,L"%s%s%s%s",L"run@",ui.lineEdit_4->text().utf16(),L"@param@",ui.lineEdit_5->text().utf16());
	    else
		wsprintf(mycommand,L"%s%s",L"run@",ui.lineEdit_4->text().utf16());

		wsprintf( CompName,L"%s%s",L"\\\\",(LPWSTR)get_list_comp.CompList.at(i).utf16());
		if (! ui.lineEdit_2->text().isEmpty() && ! ui.lineEdit->text().isEmpty())
		ConnectRemoteComp(CompName,L"IPC$",LPWSTR (ui.lineEdit_2->text().utf16()),LPWSTR (ui.lineEdit->text().utf16()),0);
        SetCommand(mycommand,(LPWSTR)get_list_comp.CompList.at(i).utf16());	
		wcscat(CompName,L"\\IPC$");
		WNetCancelConnection2(CompName, 0, NULL );


	}
}

}

void remote_assistant::on_pushButton_17_clicked()
{
	if (ui.lineEdit_6->text()!="")
		SetCommand(L"view_pict",(LPWSTR)ui.lineEdit_6->text().utf16());	
}


void remote_assistant::on_pushButton_18_clicked()
{
	    if (ui.lineEdit_6->text()!="")
		SetCommand(L"disable_screensaver",(LPWSTR)ui.lineEdit_6->text().utf16());	
}

void remote_assistant::on_pushButton_19_clicked()
{
if (MessageBox(NULL,L"      ?",L" !",MB_OKCANCEL)==IDOK)
{
	if (ui.lineEdit_6->text()!="")
    SetCommand(L"restart_my_comp",(LPWSTR)ui.lineEdit_6->text().utf16());	
}

}

void remote_assistant::on_pushButton_20_clicked()
{
TCHAR mymsg[1024];
if (ui.lineEdit_6->text()!="" && ui.lineEdit_8->text() !="")
{
wsprintf(mymsg,L"%s%s",L"r_messaga@",ui.lineEdit_8->text().utf16());
SetCommand(mymsg,(LPWSTR)ui.lineEdit_6->text().utf16());	
}
}


void remote_assistant::on_pushButton_21_clicked()
{
	if (MessageBox(NULL,L"      ?",L" !",MB_OKCANCEL)==IDOK)
	{
		if (ui.lineEdit_6->text()!="")
			SetCommand(L"sleep",(LPWSTR)ui.lineEdit_6->text().utf16());	
	}

}







